/*
*  NewsGrpDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NewsGrpDlgs.h"
//#include "newsmail.h"
#include "HelpDlgs.h"
#include "NewsMail.h"
#include "headman.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNewsGrpDlg *NewsGrpDlg;
//---------------------------------------------------------------------------
// TNewsgroupProfile
//---------------------------------------------------------------------------
bool __fastcall NewNewsgroupProfile(TForm *Owner, TNewsgroupProfile *Profile,
   TStrings *GroupsExist)
{
   bool modified = false;
   NewsGrpDlg = new TNewsGrpDlg(Owner,Profile,GroupsExist);
   NewsGrpDlg->ShowModal();
   if (NewsGrpDlg->ModalResult==mrOk && NewsGrpDlg->modified)
      modified = true;
   delete NewsGrpDlg;
   return modified;
}
//---------------------------------------------------------------------------
bool __fastcall EditNewsgroupProfile(TForm *Owner, TNewsgroupProfile *Profile)
{
   bool modified = false;
   NewsGrpDlg = new TNewsGrpDlg(Owner,Profile,NULL);
   NewsGrpDlg->ShowModal();
   if (NewsGrpDlg->ModalResult==mrOk && NewsGrpDlg->modified)
      modified = true;
   delete NewsGrpDlg;
   return modified;
}
//---------------------------------------------------------------------------
__fastcall TNewsGrpDlg::TNewsGrpDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TNewsGrpDlg::TNewsGrpDlg(TComponent* Owner, TNewsgroupProfile *Profile,
   TStrings *GroupsExist) : TForm(Owner)
{
   profile = Profile;
   existing = GroupsExist;
   CenterDialog(this,Owner);
   if (!profile->IsEmpty())
   {
      Newsgroup->Text = profile->Newsgroup();
      Download->Checked = profile->Download();
      DownloadAll->Checked = profile->DownloadAll();
      if (!Download->Checked) DownloadAll->Checked = DownloadAll->Enabled = false;
      for (int i=0; i<profile->subjects->Count; i++)
         Subjects->Lines->Add(profile->subjects->Strings[i]);

      //Newsgroup->ParentColor = true;
      //Newsgroup->ReadOnly = true;
      //Newsgroup->TabStop = false;
      //ActiveControl = Subjects;
      Subjects->SelStart = 0;
      MsgNumber->Text = profile->lastmessagenum;
   }
   Newsgroup->Modified = false;
   Subjects->Modified = false;
   modified = false;
}
//---------------------------------------------------------------------------
void __fastcall TNewsGrpDlg::GetProfile()
{
   Newsgroup->Text = profile->Newsgroup();
   Download->Checked = profile->Download();
   DownloadAll->Checked = profile->DownloadAll();
   if (!Download->Checked) DownloadAll->Checked = DownloadAll->Enabled = false;
   for (int i=0; i<profile->subjects->Count; i++)
      Subjects->Lines->Add(profile->subjects->Strings[i]);
}
//---------------------------------------------------------------------------
void __fastcall TNewsGrpDlg::SetProfile()
{
   profile->Clear();
   profile->Add("newsgroup="+Newsgroup->Text);
   profile->Add("lastmessage="+MsgNumber->Text);
   profile->Add("downloadall="+s(DownloadAll->Checked?"yes":"no"));
   profile->Add("download="+s(Download->Checked?"yes":"no"));
   for (int i=0; i<Subjects->Lines->Count; i++)
      profile->subjects->Add(Subjects->Lines->Strings[i]);
}
//---------------------------------------------------------------------------
__fastcall TNewsGrpDlg::~TNewsGrpDlg()
{
}
//---------------------------------------------------------------------------
void __fastcall TNewsGrpDlg::DownloadClick(TObject *Sender)
{
   if (!Download->Checked) DownloadAll->Checked = DownloadAll->Enabled = false;
   else DownloadAll->Enabled = true;
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TNewsGrpDlg::FieldChange(TObject *Sender)
{
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TNewsGrpDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      if (Newsgroup->Text.IsEmpty())
      {
         MsgDlg(this,"Enter a newsgroup name or click 'Cancel'","Name Error",MB_OK);
         CanClose = false;
         return;
      }
      if (Newsgroup->Text.Pos(".")==0)
      {
         MsgDlg(this,"Your newsgroup name isn't valid!","Name Error",MB_OK);
         CanClose = false;
         return;
      }
      if (existing && existing->IndexOf(Newsgroup->Text)>=0)
      {
         MsgDlg(this,"The newsgroup '"+Newsgroup->Text+"' already exists!","Name Error",MB_OK);
         CanClose = false;
         return;
      }
   }
   if (ModalResult==mrCancel && modified)
   {
      switch(ConfirmBox(this,
        "Your newsgroup profile is modified. Save your changes?",
         MB_YESNOCANCEL))
      {
         case IDCANCEL: CanClose = false;
         case IDNO    : return;
         case IDYES   : ModalResult = mrOk;
      }
   }
   if (modified) SetProfile();
}
//---------------------------------------------------------------------------
// NewsgroupProfile
//---------------------------------------------------------------------------
__fastcall TNewsgroupProfile::TNewsgroupProfile()
   : TStringList()
{
   subjects = new TStringList();
}
//---------------------------------------------------------------------------
__fastcall TNewsgroupProfile::TNewsgroupProfile(TStrings *profile)
   : TStringList()
{
   for (int i=0; i<profile->Count; i++)
      Add(profile->Strings[i]);
}
//---------------------------------------------------------------------------
__fastcall TNewsgroupProfile::~TNewsgroupProfile()
{
   delete subjects;
}
//---------------------------------------------------------------------------
int  __fastcall TNewsgroupProfile::Add(const System::AnsiString S)
{
   if (S.Pos("subject=")==1) return subjects->Add(S.SubString(9,256));
   return TStringList::Add(S);
}
//---------------------------------------------------------------------------
void __fastcall TNewsgroupProfile::Clear()
{
   TStringList::Clear();
   subjects->Clear();
}
//---------------------------------------------------------------------------
void  __fastcall TNewsgroupProfile::SetLastMessageNum(int Num)
{
   Values["lastmessage"] = Num>=0 ? s(Num) : s(-1);
}
//---------------------------------------------------------------------------
int  __fastcall TNewsgroupProfile::LastMessageNum()
{
   return Values["lastmessage"].ToIntDef(-1);
}
//---------------------------------------------------------------------------
void __fastcall TNewsgroupProfile::SetDownload(bool Down)
{
   Values["download"] = Down ? "yes":"no";
}
//---------------------------------------------------------------------------
bool __fastcall TNewsgroupProfile::Download()
{
   return Values["download"]=="yes";
}
//---------------------------------------------------------------------------
bool __fastcall TNewsgroupProfile::DownloadAll()
{
   return Values["downloadall"]=="yes";
}
//---------------------------------------------------------------------------
void __fastcall TNewsgroupProfile::SetDownloadAll(bool All)
{
   Values["downloadall"] = All ? "yes":"no";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNewsgroupProfile::Newsgroup()
{
   return Values["newsgroup"];
}
//---------------------------------------------------------------------------
void __fastcall TNewsgroupProfile::SetNewsgroup(AnsiString &name)
{
   Values["newsgroup"] = name;
}
//---------------------------------------------------------------------------
bool __fastcall TNewsgroupProfile::IsEmpty()
{
   return Count==0;
}
//---------------------------------------------------------------------------
bool __fastcall TNewsgroupProfile::subjectmatch(TStrings *msg)
{
   THeaderManager *hm = new THeaderManager(msg);
   AnsiString sub,rawsub,key,subject=hm->GetDat("Subject: ");
   delete hm;
   bool match=false;
   if (subject.IsEmpty()) return false;
   for (int i=0; i<subjects->Count; i++)
   {
      rawsub = subjects->Strings[i];
      if (rawsub.Pos("esub=")==1)
      {
         sub = GetToken(1,rawsub,";").TrimLeft();
         key = GetToken(1,GetToken(0,rawsub,";"),"=");
         if (TestSubject(subject,sub,key)==0)
         {
            THeadMan *headers = new THeadMan(msg);
            int idx = headers->Delete("Subject: ");
            msg->Insert(idx,"Subject: "+sub+" "+esub);
            match = true;
            break;
         }
      }
//if (rawsub=="mail for yamamoto") sm(rawsub+"\n"+subject);
      if (rawsub==subject)
      {
         match = true;
         break;
      }
   }
   return match;
}
//---------------------------------------------------------------------------
/*bool __fastcall TNewsgroupProfile::subjectmatch(TStrings *msg)
{
   THeaderManager *hm = new THeaderManager(msg);
   AnsiString sub,raw,key,subject=hm->GetDat("Subject: ");
   delete hm;
   if (subject.IsEmpty()) return false;
   int s=-1; while(++s<subjects->Count)
   {
      raw = subjects->Strings[s];
      if (raw==subject) return true;
      if (raw.Pos("esub=")!=1) return false;

      sub = GetToken(1,raw,";").TrimLeft();
      key = GetToken(1,GetToken(0,raw,";"),"=");
      if (TestSubject(subject,sub,key)==0) return true;
   }
   return false;
}*/
//---------------------------------------------------------------------------
bool __fastcall TNewsgroupProfile::GetSubject(int i, AnsiString &Subject, bool &Esub)
{
   Esub = false; Subject = "";
   if (!subjects->Count || i<0 || i>=subjects->Count) return false;
   Subject = subjects->Strings[i];
   if (Subject.Pos("esub=")==1)
   {
      Subject = Subject.SubString(Subject.Pos(";")+1,256).Trim();
      Esub = true;
   }
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TNewsGrpDlg::HelpBtnClick(TObject *Sender)
{
   AnsiString sections =
      s("NNTP_Newsgroup Profile Dialog\n")+
      s("NNTP_Encrypted Subjects, ESUB");
   OpenHelp2(sections,"QSnntp Newsgroup Mail","");
}
//---------------------------------------------------------------------------
