/*
*  NewsGrpDlgs.h
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#ifndef NewsGrpDlgsH
#define NewsGrpDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TNewsgroupProfile;
bool __fastcall NewNewsgroupProfile(TForm *Owner, TNewsgroupProfile *Profile,
   TStrings *GroupsExist);
bool __fastcall EditNewsgroupProfile(TForm *Owner, TNewsgroupProfile *Profile);

class TNewsGrpDlg : public TForm
{
__published:	// IDE-managed Components
   TPanel *Panel1;
   TLabel *Label2;
   TEdit *Newsgroup;
   TLabel *Label1;
   TBevel *Bevel1;
   TButton *OkBtn;
   TButton *CancelBtn;
   TButton *HelpBtn;
   TMemo *Subjects;
   TCheckBox *DownloadAll;
   TCheckBox *Download;
   TLabel *Label3;
   TEdit *MsgNumber;
   void __fastcall FieldChange(TObject *Sender);
   void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
   void __fastcall DownloadClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
   bool modified;
   HINSTANCE hESUBLib;
   TStrings *existing;
   TNewsgroupProfile *profile;
   virtual __fastcall TNewsGrpDlg(TComponent* Owner);
   virtual __fastcall TNewsGrpDlg(TComponent* Owner, TNewsgroupProfile *Profile,
      TStrings *groupsexist);
   virtual __fastcall~TNewsGrpDlg();
   void __fastcall SetProfile(); // move data from controls to profile structure
   void __fastcall GetProfile(); // move data from profile to controls
};

class TNewsgroupProfile : public TStringList
{
public:
   __property AnsiString name        = { read=Newsgroup, write=SetNewsgroup };
   __property bool download          = { read=Download, write=SetDownload };
   __property bool downloadall       = { read=DownloadAll, write=SetDownloadAll };
   __property int lastmessagenum     = { read=LastMessageNum, write=SetLastMessageNum };

   TStringList *subjects;
   virtual __fastcall TNewsgroupProfile();
   virtual __fastcall TNewsgroupProfile(TStrings *profile);
   virtual __fastcall~TNewsgroupProfile();

   AnsiString __fastcall Newsgroup();
   void __fastcall SetNewsgroup(AnsiString &name);
   bool __fastcall Download();
   void __fastcall SetDownload(bool Down);
   bool __fastcall DownloadAll();
   void __fastcall SetDownloadAll(bool Down);
   bool __fastcall GetSubject(int i, AnsiString &Subject, bool &Esub);
   void __fastcall SetLastMessageNum(int id);
   int  __fastcall LastMessageNum();
   bool __fastcall IsEmpty();
   int  __fastcall Add(const System::AnsiString S);
   bool __fastcall subjectmatch(TStrings *msg);
   void __fastcall Clear();
};

//---------------------------------------------------------------------------
extern TNewsGrpDlg *NewsGrpDlg;
extern HINSTANCE hEsubLib;
//---------------------------------------------------------------------------
#endif
