/*
*  NewsManDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NewsManDlgs.h"
#include "NewsProfDlgs.h"
#include "NewsGrpDlgs.h"
#include "HelpDlgs.h"
#include "Fileman.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma link "NntpCli"
#pragma link "explbtn"
#pragma resource "*.dfm"
TNewsManDlg *NewsManDlg;
AnsiString ExampleAccounts=
 s("server=richard@news.example2.net\r\n")+
 s("download=no\r\n")+
 s("password=abracadabra\r\n")+
 s("newsgroup=alt.anonymous.messages\r\n")+
 s("lastmessage=-1\r\n")+
 s("downloadall=yes\r\n")+
 s("download=yes\r\n")+
 s("subject=esub=shrimpcreole; mail for richard\r\n")+
 s("subject=mail for richard\r\n")+
 s("\r\n")+
 s("server=news.example.net\r\n")+
 s("download=no\r\n")+
 s("newsgroup=alt.anonymous.messages\r\n")+
 s("lastmessage=-1\r\n")+
 s("downloadall=yes\r\n")+
 s("download=yes\r\n")+
 s("subject=mail for quicksilver\r\n")+
 s("subject=esub=foobar; mail for richard");
//---------------------------------------------------------------------------
bool __fastcall RunNewsProfileManager(TForm *Owner, TNewsProfileList *Profiles, bool &getnewsnow)
{
   //if (FileExists(AppNewsDat) && FileExists(AppMainDat))
   //{
   //}
   NewsManDlg = new TNewsManDlg(Owner,Profiles);
   NewsManDlg->ShowModal();
//sm("ok");
   if (NewsManDlg->ModalResult==mrOk)
   {
      if (NewsManDlg->modified) Profiles->modified = true;
      getnewsnow = NewsManDlg->getnewsnow;
   }
   delete NewsManDlg;
   return Profiles->modified;
}
//---------------------------------------------------------------------------
bool __fastcall RunNewsProfileManagerNoGet(TForm *Owner, TNewsProfileList *Profiles)
{
   NewsManDlg = new TNewsManDlg(Owner,Profiles);
   NewsManDlg->allowget = false;
   NewsManDlg->ShowModal();
   if (NewsManDlg->ModalResult==mrOk)
   {
      if (NewsManDlg->modified) Profiles->modified = true;
   }
   delete NewsManDlg;
   return Profiles->modified;
}
//---------------------------------------------------------------------------
bool __fastcall GetNextProfile(TStrings *profile, TStrings *profiles, int &pos)
{
   profile->Clear();
   while(pos<profiles->Count && profiles->Strings[pos].Pos("server=")!=1) pos++;
   while(pos<profiles->Count && profiles->Strings[pos].Trim()!="")
   {
      AnsiString line = profiles->Strings[pos];
      profile->Add(line);
      pos++;
   }
   return profile->Count;
}
//---------------------------------------------------------------------------
__fastcall TNewsManDlg::TNewsManDlg(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TNewsManDlg::TNewsManDlg(TComponent* Owner, TNewsProfileList *Profiles)
  : TForm(Owner)
{
   CenterDialog(this,Owner);
   profiles = Profiles;
   nodes = new TList();
   LoadTreeView();
   modified = false;
   allowget = true;
}
//---------------------------------------------------------------------------
__fastcall TNewsManDlg::~TNewsManDlg()
{
   //for (int i=0; i<profiles->Count; i++)   These are deleted at a higher level
   //   delete profiles->Objects[i];
   //delete profiles;
   delete nodes;
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::NewBtnClick(TObject *Sender)
{
   TNewsProfile *nprofile = new TNewsProfile();
   if (NewAccountProfile(this,nprofile,profiles))
   {
      profiles->AddProfile(nprofile);
      LoadTreeView();
      modified = true;
      return;
   }
   delete nprofile;
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::EditBtnClick(TObject *Sender)
{
   if (!TreeView->Selected) return;
   TTreeNode *node = TreeView->Selected;
   while (node->Level>0) node = node->Parent;
   TNewsProfile *profile = (TNewsProfile*)node->Data;

   if (EditAccountProfile(this,profile))
   {
      if (!profile->download)
      {
         for (int i=0; i<profile->newsgroups->Count; i++)
         {
            TNewsgroupProfile *group = (TNewsgroupProfile*)profile->newsgroups->Objects[i];
            if (group->download) group->download = false;
         }
      }
      modified = true;
      LoadTreeView();
   }
   TreeView->Selected = NULL;
   DeleteBtn->Enabled = NULL;
   EditBtn->Enabled = false;
   AcctDn->Enabled = false;
   AcctUp->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::DeleteBtnClick(TObject *Sender)
{
   TTreeNode *node = TreeView->Selected;
   if (!node) return;

   while(node->Level>0) node = node->Parent;
   if (ConfirmBox(this,
      "DELETE the news profile: "+node->Text+"\nAre you sure?",
       MB_OKCANCEL)==IDOK)
   {
      TNewsProfile *profile = (TNewsProfile*)node->Data;
      for (int i=0; i<profiles->Count; i++)
      {
         if (profiles->profile(i)==profile)
         {
            profiles->DeleteProfile(i);
            break;
         }
      }
      LoadTreeView();
      modified = true;
   }
   TreeView->Selected = NULL;
   DeleteBtn->Enabled = NULL;
   EditBtn->Enabled = false;
   AcctDn->Enabled = false;
   AcctUp->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::SetNothingSelected()
{
   TreeView->Selected = NULL;
   DeleteBtn->Enabled = false;
   EditBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::SetProfileImages(TTreeNode *anode)
{
   if (!anode) anode = TreeView->Selected;
   if (!anode) return;

   while (anode->Level>0) anode = anode->Parent;
   for (int i=0; i<nodes->Count; i++)
   {
      TTreeNode *node = (TTreeNode*)nodes->Items[i];
      if (node==TreeView->Items->GetFirstNode())
         node->SelectedIndex = 1;
      else
         node->SelectedIndex = 0;
      if (profiles->profile(i)->download) node->SelectedIndex = 1;
      node->ImageIndex = node->SelectedIndex;
   }
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::LoadTreeView()
{
   TNewsProfile *profile;
   TNewsgroupProfile *gprofile;
   AnsiString line,server,userid,password,subject;
   TTreeNode *anode,*cnode,*enode;
   TreeView->Items->BeginUpdate();
   TreeView->Items->Clear();
   nodes->Clear();
   for (int i=0; i<profiles->Count; i++)
   {
      profile = (TNewsProfile*)profiles->Objects[i];
      server = profile->Values["server"];
      if (server.IsEmpty()) continue;

      anode = TreeView->Items->AddChildObject(TreeView->Selected,server,profile);
      anode->SelectedIndex = anode->ImageIndex = profile->download ? 1:0;
      nodes->Add(anode);

      if (profile->newsgroups->Count)
      {
         for (int n=0; n<profile->newsgroups->Count; n++)
         {
            int s=-1; bool esub;
            gprofile = (TNewsgroupProfile*)profile->newsgroups->Objects[n];
            AnsiString newsgroup = gprofile->Newsgroup();
            newsgroup += gprofile->DownloadAll()?" /all":"";
            cnode = TreeView->Items->AddChildObject(anode,newsgroup,gprofile);
            //if (newsgroup.Pos("password: ")==1) index = -1;
            cnode->SelectedIndex = cnode->ImageIndex = gprofile->download ? 1:0;
            while(gprofile->GetSubject(++s,subject,esub))
            {
               enode = TreeView->Items->AddChildObject(cnode,subject,gprofile);
               enode->SelectedIndex = enode->ImageIndex = esub ? 2:-1;
            }
         }
      }
   }
   Snooze(20);
   TreeView->Items->EndUpdate();
   AppProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::TreeViewMouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
   bool canmove = TreeView->Selected && TreeView->Selected->Level==0;
   AcctUp->Enabled = AcctDn->Enabled = canmove;
   TNewsProfile *profile;
   TNewsgroupProfile *gprofile;
   THitTests HitTest = TreeView->GetHitTestInfoAt(X,Y);
   if (HitTest.Contains(htOnIcon))
   {
      TTreeNode *node=TreeView->Selected;
      if (node)
      {
         TreeView->Items->BeginUpdate();
         if (node->Level==0)
         {
            profile = (TNewsProfile*)node->Data;
            profile->download = !profile->download;
            node->SelectedIndex = node->ImageIndex = profile->download ? 1:0;
            modified = true;
         }

         if (node->Level==1)
         {
            gprofile = (TNewsgroupProfile*)node->Data;
            gprofile->download = !gprofile->download;
            node->SelectedIndex = node->ImageIndex = gprofile->download ? 1:0;
            modified = true;
         }
         TreeView->Items->EndUpdate();
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::CollapseBtnClick(TObject *Sender)
{
   TreeView->FullCollapse();
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::ExpandBtnClick(TObject *Sender)
{
   TreeView->FullExpand();
   TreeView->TopItem = TreeView->Items->GetFirstNode();
   TreeView->Selected = TreeView->TopItem;
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::TreeViewClick(TObject *Sender)
{
   TTreeNode *node = TreeView->Selected;
   if (node)
   {
      DeleteBtn->Enabled = node->Level==0;
      EditBtn->Enabled = true;//TreeView->Selected->Level==0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
   TTreeNode *node = TreeView->Selected;
   if (node)
   {
      DeleteBtn->Enabled = node->Level==0;
      EditBtn->Enabled = true; //node->Level==0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel && modified)
   {
      switch(ConfirmBox(this,
         "Your news profiles are modified! Save your changes?",
          MB_YESNOCANCEL))
      {
         case IDCANCEL: CanClose = false;
         case IDNO    : break;
         case IDYES   : ModalResult = mrOk;
      }
   }
}
//---------------------------------------------------------------------------
/*void __fastcall TNewsManDlg::GetRawProfiles(TStrings *Rawprofiles)
{
   Rawprofiles->Clear();
   for (int p=0; p<profiles->Count; p++)
   {
      TNewsProfile *profile = profiles->profile(p);
      for (int i=0; i<profile->Count; i++) Rawprofiles->Add(profile->Strings[i]);
      for (int g=0; g<profile->newsgroups->Count; g++)
      {
         TNewsgroupProfile *group = (TNewsgroupProfile*) profile->newsgroups->Objects[g];
         for (int i=0; i<group->Count; i++) Rawprofiles->Add(group->Strings[i]);
      }
      if (p<profiles->Count-1) Rawprofiles->Add("");
   }
}*/
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::AcctUpClick(TObject *Sender)
{
   TTreeNode *node = TreeView->Selected;
   if (!node || node->Level>0) return;

   TNewsProfile *profile=(TNewsProfile*)node->Data;
   AnsiString compname,profname=profile->Values["server"];
   int idx=-1; for (int i=1; i<profiles->Count; i++)
   {
      compname = profiles->profile(i)->Values["server"];
      if (compname==profname)
      {
         idx = i;
         break;
      }
   }
   if (idx>0) profiles->Move(idx,idx-1);
   else
   {
      MessageBeep(MB_OK);
      return;
   }
   LoadTreeView();
   TreeView->Selected = (TTreeNode*)nodes->Items[idx-1];
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::AcctDnClick(TObject *Sender)
{
   TTreeNode *node = TreeView->Selected;
   if (!node || node->Level>0) return;

   TNewsProfile *profile=(TNewsProfile*)node->Data;
   AnsiString compname,profname=profile->Values["server"];
   int idx=-1; for (int i=0; i<profiles->Count; i++)
   {
      compname = profiles->profile(i)->Values["server"];
      if (compname==profname)
      {
         idx = i;
         break;
      }
   }
   if (idx>=0 && idx<profiles->Count-1) profiles->Move(idx,idx+1);
   else
   {
      MessageBeep(MB_OK);
      return;
   }
   LoadTreeView();
   TreeView->Selected = (TTreeNode*)nodes->Items[idx+1];
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::GetBtnClick(TObject *Sender)
{
   //Hide(); if (!Application->ShowMainForm) Snooze(200); Close();
   //Application->ShowMainForm = true;
   //AppMainForm->Visible = true;
   Snooze(100);
   getnewsnow = true;
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
// TNewsProfileList
//---------------------------------------------------------------------------
__fastcall TNewsProfileList::TNewsProfileList()
{
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TNewsProfileList::TNewsProfileList(AnsiString DataFile)
{
   datafile = DataFile;
   profileskey = NewsProfilesKey;
   TStringList *rawprofiles = new TStringList();
   GetAppData(rawprofiles,profileskey,datafile);
if (!rawprofiles->Count) rawprofiles->Text = ExampleAccounts;
//view(rawprofiles);
int e,i=-1; while(++i<rawprofiles->Count)
{
   AnsiString line = rawprofiles->Strings[i];
   if (line.Pos("server=")==1 && (e=line.Pos("@"))>0 && rawprofiles->Strings[i+1].Pos("login=")!=1)
   {
      rawprofiles->Insert(i+1,"login="+line.SubString(8,e-8));
      PutAppData(profileskey,rawprofiles,DataFile);
   }
}
//view(rawprofiles);
   AddRawProfiles(rawprofiles);
   delete rawprofiles;
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TNewsProfileList::~TNewsProfileList()
{
   for (int i=0; i<Count; i++)
       delete profile(i);
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfileList::DeleteProfile(int index)
{
   if (index<0 || index>=Count) return;
   delete profile(index);
   Delete(index);
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfileList::AddProfile(TNewsProfile *Profile)
{
   AddObject(Profile->name,Profile);
   modified = true;
}
//---------------------------------------------------------------------------
int __fastcall TNewsProfileList::AddRawProfiles(TStrings *rawprofiles)
{
   TStringList *lines = new TStringList();
   int pos=0; while(GetNextProfile(lines,rawprofiles,pos))
   {
      TNewsProfile *profile = new TNewsProfile(lines);
      AddObject(profile->name,profile);
   }
   modified = true;
   delete lines;
   return Count;
}
//---------------------------------------------------------------------------
int __fastcall TNewsProfileList::GetRawProfiles(TStrings *rawprofiles)
{
   rawprofiles->Clear();
   for (int i=0; i<Count; i++)
   {
      if (i>0) rawprofiles->Add("");
      profile(i)->GetRawProfile(rawprofiles);
   }
   return Count;
}
//---------------------------------------------------------------------------
int __fastcall TNewsProfileList::GetRawProfiles4Ini(TStrings *rawprofiles)
{
   rawprofiles->Clear();
   for (int i=0; i<Count; i++)
   {
      if (i>0) rawprofiles->Add("");
      profile(i)->GetRawProfile4Ini(rawprofiles);
   }
   return Count;
}
//---------------------------------------------------------------------------
TNewsProfile* __fastcall TNewsProfileList::profile(int index)
{
   if (index>=0 && index<Count) return (TNewsProfile*)Objects[index];
   return NULL;
}
//---------------------------------------------------------------------------
TNewsProfile* __fastcall TNewsProfileList::profile(AnsiString name)
{
   int i=-1; while(++i<Count)
      if (profile(i)->name==name) return profile(i);
   return NULL;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfileList::LoadFromDatabase()
{
   TStringList *rawprofiles = new TStringList();
   GetAppData(rawprofiles,profileskey,datafile);
   AddRawProfiles(rawprofiles);
   delete rawprofiles;
   modified = false;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfileList::SaveToDatabase()
{
   TStringList *rawprofiles = new TStringList();
   GetRawProfiles(rawprofiles);
   PutAppData(profileskey,rawprofiles,datafile);
   delete rawprofiles;
   modified = false;
}
//---------------------------------------------------------------------------
bool __fastcall TNewsProfileList::HasSubjects()
{
   bool has=false;
   for (int p=0; p<Count; p++)
   {
      for (int g=0; g<profile(p)->newsgroups->Count; g++)
      {
         if (profile(p)->newsgroup(g)->subjects->Count)
         {
            has = true;
            break;
         }
      }
      if (has) break;
   }
   return has;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfileList::Save()
{
   if (SecureMode()) SaveToIniFile(AppNewsDat);
   else if (HasSubjects()) SaveToDataFile(AppMainDat);
   SaveToIniFile(AppNewsIni);
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfileList::SaveToIniFile(AnsiString &IniFile)
{  // save profiles without subjects
   TStringList *rawprofiles = new TStringList();
   GetRawProfiles4Ini(rawprofiles);
   PutAppData(profileskey,rawprofiles,IniFile);
   delete rawprofiles;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfileList::SaveToDataFile(AnsiString &DataFile)
{  // save profiles with subjects
   TStringList *rawprofiles = new TStringList();
   GetRawProfiles(rawprofiles);
   PutAppData(profileskey,rawprofiles,DataFile);
   delete rawprofiles;
   modified = false;
}
//---------------------------------------------------------------------------
bool __fastcall TNewsProfileList::SecureMode()
{
   return !FileExists(AppMainDat);//&& FileExists(AppMainPgp);
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::FormShow(TObject *Sender)
{
   GetBtn->Enabled = allowget;
}
//---------------------------------------------------------------------------
void __fastcall TNewsManDlg::HelpBtnClick(TObject *Sender)
{
   AnsiString sections =
      s("NNTP_Accounts Manager Dialog\n")+
      s("NNTP_Encrypted Subjects, ESUB\n")+
      s("NNTP_Important ESUB Getting Started Info");
   OpenHelp2(sections,"","Accounts Manager Dialog");
}
//---------------------------------------------------------------------------
