/*
*  NewsManDlgs.h
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#ifndef NewsManDlgsH
#define NewsManDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Buttons.hpp>
#include "NntpCli.hpp"
#include "explbtn.hpp"
#include "global.h"
//---------------------------------------------------------------------------
class TNewsProfile;
class TNewsProfileList;

bool __fastcall RunNewsProfileManager(TForm *Owner, TNewsProfileList *Profiles, bool &getnewsnow);
bool __fastcall RunNewsProfileManagerNoGet(TForm *Owner, TNewsProfileList *Profiles);
bool __fastcall GetNextProfile(TStrings *profile, TStrings *profiles, int &pos);

class TNewsManDlg : public TForm
{
__published:	// IDE-managed Components
   TPanel *Panel1;
   TButton *NewBtn;
   TButton *EditBtn;
   TButton *DeleteBtn;
   TButton *CancelBtn;
   TPanel *Panel2;
   THeaderControl *HeaderControl1;
   TPopupMenu *PopupMenu;
   TMenuItem *PopGetMailItem;
   TMenuItem *PopGetThisItem;
   TMenuItem *PopToggleItem;
   TMenuItem *N1;
   TSpeedButton *AcctUp;
   TSpeedButton *AcctDn;
   TMenuItem *PopNewItem;
   TMenuItem *PopOpenItem;
   TMenuItem *PopDeleteItem;
   TMenuItem *N2;
   TButton *OkBtn;
   TBitBtn *GetBtn;
   TButton *HelpBtn;
   TTreeView *TreeView;
   TImageList *ImageList1;
   TOfficeButton *ExpandBtn;
   TOfficeButton *CollapseBtn;
	TImageList *ImageList2;
   void __fastcall EditBtnClick(TObject *Sender);
   void __fastcall CollapseBtnClick(TObject *Sender);
   void __fastcall ExpandBtnClick(TObject *Sender);
   void __fastcall TreeViewClick(TObject *Sender);
   void __fastcall TreeViewChange(TObject *Sender, TTreeNode *Node);
   void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
   void __fastcall DeleteBtnClick(TObject *Sender);
   void __fastcall TreeViewMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y);
   void __fastcall NewBtnClick(TObject *Sender);
   void __fastcall AcctUpClick(TObject *Sender);
   void __fastcall AcctDnClick(TObject *Sender);
   void __fastcall GetBtnClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
public:		// User declarations
   TList *nodes;
   bool modified,getnewsnow,allowget;
   TNewsProfileList *profiles;
   virtual __fastcall TNewsManDlg(TComponent* Owner);
   virtual __fastcall TNewsManDlg(TComponent* Owner, TNewsProfileList *Profiles);
   virtual __fastcall~TNewsManDlg();
   void __fastcall SetProfileImages(TTreeNode *node);
   void __fastcall SetNothingSelected();
   void __fastcall LoadTreeView();
};

class TNewsProfileList : public TStringList
{
public:
   bool modified;
   AnsiString datafile,profileskey;
   virtual __fastcall TNewsProfileList();
   virtual __fastcall TNewsProfileList(AnsiString DataFile);
   virtual __fastcall~TNewsProfileList();
   TNewsProfile* __fastcall profile(int index);
   TNewsProfile* __fastcall profile(AnsiString name);
   int  __fastcall AddRawProfiles(TStrings *fromrawprofiles);
   int  __fastcall GetRawProfiles4Ini(TStrings *torawprofiles);
   int  __fastcall GetRawProfiles(TStrings *torawprofiles);
   void __fastcall AddProfile(TNewsProfile *Profile);
   void __fastcall DeleteProfile(int index);
   bool __fastcall SecureMode();
   void __fastcall LoadFromDatabase();
   bool __fastcall HasSubjects();
   void __fastcall SaveToDatabase();
   void __fastcall SaveToDataFile(AnsiString &DataFile);
   void __fastcall SaveToIniFile(AnsiString &IniFile);
   void __fastcall Save();
};

//---------------------------------------------------------------------------
extern TNewsManDlg *NewsManDlg;
//---------------------------------------------------------------------------
#endif
