/*
*  NewsProfDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NewsProfDlgs.h"
#include "NewsManDlgs.h"
#include "NewsGrpDlgs.h"
#include "HelpDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TNewsProfDlg *NewsProfDlg;
//---------------------------------------------------------------------------
bool __fastcall NewAccountProfile(TForm *Owner, TNewsProfile *Profile, TStrings *ProfilesExist)
{
   bool modified=false;
   NewsProfDlg = new TNewsProfDlg(Owner,Profile,ProfilesExist);
   NewsProfDlg->ShowModal();
   if (NewsProfDlg->ModalResult==mrOk && NewsProfDlg->modified)
      modified = true;
   delete NewsProfDlg;
   return modified;
}
//---------------------------------------------------------------------------
bool __fastcall EditAccountProfile(TForm *Owner, TNewsProfile* Profile)
{
   bool modified=false;
   NewsProfDlg = new TNewsProfDlg(Owner,Profile,NULL);
   NewsProfDlg->ShowModal();
   if (NewsProfDlg->ModalResult==mrOk && NewsProfDlg->modified)
      modified = true;
   delete NewsProfDlg;
   return modified;
}
//---------------------------------------------------------------------------
__fastcall TNewsProfDlg::TNewsProfDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);
   nodes = new TList();
   modified = false;
   LoadTreeView();
}
//---------------------------------------------------------------------------
__fastcall TNewsProfDlg::TNewsProfDlg(TComponent* Owner, TNewsProfile *Profile,
   TStrings *ProfsExist) : TForm(Owner)
{
   profile = Profile;
   existing = ProfsExist;
   CenterDialog(this,Owner);
   if (!Profile->IsEmpty())
   {
      GetProfile();
      //NNTPHost->ParentColor = true;
      //NNTPHost->ReadOnly = true;
      //NNTPHost->TabStop = false;
      //ActiveControl = AccountUID;
   }
   nodes = new TList();
   modified = false;
   LoadTreeView();
   TreeView->FullExpand();
   TreeView->TopItem = TreeView->Items->GetFirstNode();
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::GetProfile()
{
   NNTPHost->Text = profile->Server();
   AccountUID->Text = profile->UserID();
   Password->Text = profile->Password();
   Download->Checked = profile->Download();
   Remember->Checked = !Password->Text.IsEmpty();
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::SetProfile()
{
   int p; AnsiString uid=AccountUID->Text,server=NNTPHost->Text;
   if (!uid.IsEmpty())
   {
      if ((p=uid.Pos("@"))>0) server = uid.SubString(1,p)+server;
      else server = uid+"@"+server;
   }
   //if (!AccountUID->Text.IsEmpty()) server = AccountUID->Text+"@"+server;
   profile->Values["login"] = uid;
   profile->Values["server"] = server;
   profile->Values["download"] = Download->Checked?"yes":"no";
   profile->Values["password"] = Remember->Checked?Password->Text:s("");
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::SetNothingSelected()
{
   TreeView->Selected = NULL;
   DeleteBtn->Enabled = false;
   EditBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::SetProfileImages(TTreeNode *anode)
{
   /*if (!anode) anode = TreeView->Selected;
   if (!anode) anode = TreeView->TopItem;
   if (!anode) return;

   int index;
   TTreeNode *cnode;
   while (anode->Level>0) anode = anode->Parent;
   TNewsgroupProfile *gprofile = (TNewsgroupProfile*)anode->Data;

   index = gprofile->download ? 1:0;
   anode->SelectedIndex = index;
   anode->ImageIndex = index;

   for (int i=0; i<anode->Count; i++)
   {
      cnode = anode->Item[i];
      if (gprofile->subjects->Strings[i].Pos("esub=")==1) index = passkey;
      else index = str8line;
      cnode->SelectedIndex = index;
      cnode->ImageIndex = index;
   }
   InvalidateRect(TreeView->Handle,NULL,false);*/
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::LoadTreeView()
{
   bool esub;
   TTreeNode *cnode,*node;
   AnsiString subject,group;
   TreeView->Items->BeginUpdate();
   TreeView->Items->Clear();
   nodes->Clear();
   for (int n=0; n<profile->newsgroups->Count; n++)
   {
      gprofile = (TNewsgroupProfile*)profile->newsgroup(n);
      group = gprofile->name+(gprofile->downloadall?" /all":"");
      node = TreeView->Items->AddChildObject(TreeView->Selected,group,gprofile);
      node->SelectedIndex = node->ImageIndex = gprofile->download ? 1:0;
      int s=-1; while(gprofile->GetSubject(++s,subject,esub))
      {
         cnode = TreeView->Items->AddChildObject(node,subject,gprofile);
         cnode->SelectedIndex = cnode->ImageIndex = esub ? 2:-1;
      }
      nodes->Add(node);
   }
   Snooze(20);
   TreeView->Items->EndUpdate();
   SetNothingSelected();
   AppProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::TreeViewMouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
   THitTests HitTest = TreeView->GetHitTestInfoAt(X, Y);
   if (HitTest.Contains(htOnIcon))
   {
      TreeView->Items->BeginUpdate();
      TTreeNode *node = TreeView->Selected;
      if (node && node->Level==0)
      {
         gprofile = (TNewsgroupProfile*)node->Data;
         gprofile->download = !gprofile->download;
         node->SelectedIndex = node->ImageIndex = gprofile->download ? 1:0;
         modified = true;
      }
      Snooze(10);
      TreeView->Items->EndUpdate();
  }
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::FieldChange(TObject *Sender)
{
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      if (NNTPHost->Text.IsEmpty())
      {
         MsgDlg(this,"Enter a news server name or click 'Cancel'","Name Error",MB_OK);
         CanClose = false;
         return;
      }
      if (NNTPHost->Text.Pos(".")==0)
      {
         MsgDlg(this,"Your news server name isn't valid!","Name Error",MB_OK);
         CanClose = false;
         return;
      }
      if (existing && existing->IndexOf(NNTPHost->Text)>=0)
      {
         MsgDlg(this,"The news server '"+NNTPHost->Text+"' already exists!","Name Error",MB_OK);
         CanClose = false;
         return;
      }
   }
   if (ModalResult==mrCancel && modified)
   {
      switch (ConfirmBox(this,
         "Your news profile is modified. Save your changes?",
          MB_YESNOCANCEL))
      {
         case IDCANCEL: CanClose = false;
         case IDNO    : return;
         case IDYES   : ModalResult = mrOk;
      }
   }
   if (modified) SetProfile();
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::GrpUpClick(TObject *Sender)
{
   TTreeNode *node = TreeView->Selected;
   if (!node || node->Level>0)
   {
      MessageBeep(MB_OK);
      return;
   }

   TNewsgroupProfile *gprofile = (TNewsgroupProfile*)node->Data;
   AnsiString cmpname,grpname = gprofile->name;
   int idx=-1; for (int i=0; i<profile->newsgroups->Count; i++)
   {
      cmpname = profile->newsgroup(i)->name;
      if (cmpname==grpname)
      {
         idx = i;
         break;
      }
   }
   if (idx>0) profile->newsgroups->Move(idx,idx-1);
   else
   {
      MessageBeep(MB_OK);
      return;
   }
   LoadTreeView();
   TreeView->Selected = (TTreeNode*)nodes->Items[idx-1];
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::GrpDnClick(TObject *Sender)
{
   TTreeNode *node = TreeView->Selected;
   if (!node || node->Level>0)
   {
      MessageBeep(MB_OK);
      return;
   }

   TNewsgroupProfile *gprofile=(TNewsgroupProfile*)node->Data;
   AnsiString cmpname,grpname=gprofile->name;
   int idx=-1; for (int i=0; i<profile->newsgroups->Count; i++)
   {
      cmpname = profile->newsgroup(i)->name;
      if (cmpname==grpname)
      {
         idx = i;
         break;
      }
   }
   if (idx>=0 && idx<profile->newsgroups->Count-1)
      profile->newsgroups->Move(idx,idx+1);
   else
   {
      MessageBeep(MB_OK);
      return;
   }
   LoadTreeView();
   TreeView->Selected = (TTreeNode*)nodes->Items[idx+1];
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
   TTreeNode *node = TreeView->Selected;
   if (node)
   {
      DeleteBtn->Enabled = node->Level==0;
      EditBtn->Enabled = true; //node->Level==0;
      GrpUp->Enabled = true;
      GrpDn->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::NewBtnClick(TObject *Sender)
{
   TNewsgroupProfile *gprofile = new TNewsgroupProfile();
   if (NewNewsgroupProfile(this,gprofile,profile->newsgroups))
   {
      if (gprofile->Download()) Download->Checked = true;
      profile->newsgroups->AddObject(gprofile->Strings[0],gprofile);
      LoadTreeView(); TreeView->FullExpand();
      GrpUp->Enabled = false;
      GrpDn->Enabled = false;
      modified = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::EditBtnClick(TObject *Sender)
{
   if (!TreeView->Selected) return;
   TTreeNode *node = TreeView->Selected;
   TNewsgroupProfile *gprofile = (TNewsgroupProfile*)node->Data;
   if (EditNewsgroupProfile(this,gprofile))
   {
      if (gprofile->Download()) Download->Checked = true;
      LoadTreeView(); TreeView->FullExpand();
      modified = true;
   }
   TreeView->Selected = NULL;
   DeleteBtn->Enabled = false;
   EditBtn->Enabled = false;
   GrpUp->Enabled = false;
   GrpDn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::DeleteBtnClick(TObject *Sender)
{
   TTreeNode *node = TreeView->Selected;
   if (!node) return;

   while(node->Level>0) node = node->Parent;
   if (ConfirmBox(this,
      "DELETE the newsgroup: "+GetToken(0,node->Text," ")+"\nAre you sure?",
       MB_OKCANCEL)==IDOK)
   {
      gprofile = (TNewsgroupProfile*)node->Data;
      for (int i=0; i<profile->newsgroups->Count; i++)
      {
         if (profile->newsgroup(i)==gprofile)
         {
            profile->newsgroups->Delete(i);
            delete gprofile;
            break;
         }
      }
      //TreeView->Items->Delete(node);
      LoadTreeView();
      //GrpUp->Enabled = false;
      //GrpDn->Enabled = false;
      modified = true;
   }
   TreeView->Selected = NULL;
   DeleteBtn->Enabled = false;
   EditBtn->Enabled = false;
   GrpUp->Enabled = false;
   GrpDn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::HideTypeClick(TObject *Sender)
{
   if (HideType->Checked) Password->PasswordChar = '*';
   else Password->PasswordChar = '\0';
}
//---------------------------------------------------------------------------
// NewsProfile
//---------------------------------------------------------------------------
__fastcall TNewsProfile::TNewsProfile()
   : TStringList()
{
   newsgroups = new TStringList();
}
//---------------------------------------------------------------------------
__fastcall TNewsProfile::TNewsProfile(TStrings *Profile)
   : TStringList()
{
   newsgroups = new TStringList();
   SetRawProfile(Profile);
}
//---------------------------------------------------------------------------
__fastcall TNewsProfile::~TNewsProfile()
{
   for (int i=0; i<newsgroups->Count; i++)
      delete newsgroups->Objects[i];
   delete newsgroups;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfile::Clear()
{
   TStringList::Clear();
   for (int i=0; i<newsgroups->Count; i++)
      delete newsgroup(i);
   newsgroups->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfile::GetRawProfile(TStrings *rawprofile)
{
   rawprofile->AddStrings(this);
   for (int i=0; i<newsgroups->Count; i++)
   {
      rawprofile->AddStrings(newsgroup(i));
      for (int n=0; n<newsgroup(i)->subjects->Count; n++)
         rawprofile->Add("subject="+newsgroup(i)->subjects->Strings[n]);
   }
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfile::GetRawProfile4Ini(TStrings *rawprofile)
{
   rawprofile->AddStrings(this);
   for (int i=0; i<newsgroups->Count; i++)
      rawprofile->AddStrings(newsgroup(i));
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfile::SetRawProfile(TStrings *rawprofile)
{
   Clear();
   AnsiString line;
   newsgroups = new TStringList();
   int i=-1; while (++i<rawprofile->Count)
   {
      line = rawprofile->Strings[i];
      if (line.Pos("newsgroup=")==1) break;
      Add(line);
   }
   while (i<rawprofile->Count && (line=rawprofile->Strings[i]).Pos("newsgroup=")==1)
   {
      TNewsgroupProfile *gprofile = new  TNewsgroupProfile();
      gprofile->Add(line);
      while(++i<rawprofile->Count)
      {
         if ((line=rawprofile->Strings[i]).Pos("newsgroup=")==1) break;
         gprofile->Add(line);
      }
      newsgroups->AddObject(gprofile->name,gprofile);
   }
}
//---------------------------------------------------------------------------
TNewsgroupProfile* __fastcall TNewsProfile::newsgroup(int index)
{
   if (index>=0 && index<newsgroups->Count)
      return (TNewsgroupProfile*)newsgroups->Objects[index];
   return NULL;
}
//---------------------------------------------------------------------------
TNewsgroupProfile* __fastcall TNewsProfile::newsgroup(AnsiString name)
{
   int i=-1; while(++i<newsgroups->Count)
      if (newsgroup(i)->name==name) return newsgroup(i);
   return NULL;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNewsProfile::Server()
{
   int p; AnsiString server=Values["server"];
   if ((p=server.Pos("@"))==0) return server;
   return server.SubString(p+1,256);
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfile::SetServer(AnsiString &server)
{
   int p; AnsiString uid=UserID();
   if (!uid.IsEmpty() && (p=uid.Pos("@"))>0) server = uid.SubString(1,p)+server;
   Values["server"] = server;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNewsProfile::UserID()
{
   return Values["login"];
}
//---------------------------------------------------------------------------
//AnsiString __fastcall TNewsProfile::UserID()
//{
//   int p; AnsiString server = Values["server"];
//   if ((p=server.Pos("@"))==0) return "";
//   return server.SubString(1,p-1);
//}
//---------------------------------------------------------------------------
void __fastcall TNewsProfile::SetUserID(AnsiString &user)
{
   int p; AnsiString login=Values["login"],server=Values["server"];
   if ((p=login.Pos("@"))>0) Values["server"] = login.SubString(1,p)+Server();
   Values["login"] = login;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNewsProfile::Password()
{
   return Values["password"];
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfile::SetPassword(AnsiString &password)
{
   Values["password"] = password;
}
//---------------------------------------------------------------------------
bool __fastcall TNewsProfile::Download()
{
   return Values["download"]=="yes";
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfile::SetDownload(bool Down)
{
   Values["download"] = Down ? "yes":"no";
}
//---------------------------------------------------------------------------
bool __fastcall TNewsProfile::IsEmpty()
{
   return Count==0;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::ExpandBtnClick(TObject *Sender)
{
   TreeView->FullExpand();
   TreeView->TopItem = TreeView->Items->GetFirstNode();
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::CollapseBtnClick(TObject *Sender)
{
   TreeView->FullCollapse();
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg::HelpBtnClick(TObject *Sender)
{
   AnsiString sections =
      s("NNTP_Account Profile Dialog\n")+
      s("NNTP_Encrypted Subjects, ESUB");
   OpenHelp2(sections,"QSnntp Newsgroup Mail","");
}
//---------------------------------------------------------------------------
