/*
*  NewsProfDlgs.h
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#ifndef NewsProfDlgsH
#define NewsProfDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Buttons.hpp>
#include "NewsGrpDlgs.h"
#include "explbtn.hpp"
//---------------------------------------------------------------------------
class TNewsProfile;
bool __fastcall NewAccountProfile(TForm *Owner, TNewsProfile *Profile,
   TStrings *ProfilesExist);
bool __fastcall EditAccountProfile(TForm *Owner, TNewsProfile *Profile);

class TNewsProfDlg : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TButton *OkBtn;
	TButton *CancelBtn;
	TButton *HelpBtn;
	TGroupBox *GroupBox1;
	TButton *NewBtn;
	TButton *DeleteBtn;
	TTreeView *TreeView;
	TButton *EditBtn;
	TGroupBox *GroupBox2;
	TEdit *NNTPHost;
	TCheckBox *Download;
	TGroupBox *GroupBox3;
	TLabel *Label1;
	TEdit *AccountUID;
	TLabel *Label2;
	TCheckBox *HideType;
	TEdit *Password;
	TCheckBox *Remember;
	TSpeedButton *GrpDn;
	TSpeedButton *GrpUp;
	TImageList *ImageList1;
	TOfficeButton *ExpandBtn;
	TOfficeButton *CollapseBtn;
	void __fastcall NewBtnClick(TObject *Sender);
	void __fastcall FieldChange(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall GrpUpClick(TObject *Sender);
	void __fastcall GrpDnClick(TObject *Sender);
	void __fastcall TreeViewChange(TObject *Sender, TTreeNode *Node);
	void __fastcall EditBtnClick(TObject *Sender);
	void __fastcall TreeViewMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y);
	void __fastcall DeleteBtnClick(TObject *Sender);
	void __fastcall HideTypeClick(TObject *Sender);
	void __fastcall ExpandBtnClick(TObject *Sender);
	void __fastcall CollapseBtnClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    bool modified;
    TList *nodes;
    TStrings *existing;
    TNewsProfile *profile;
    TNewsgroupProfile *gprofile;
	virtual __fastcall TNewsProfDlg(TComponent* Owner);
	virtual __fastcall TNewsProfDlg(TComponent* Owner, TNewsProfile *Profiles,
       TStrings *ProfilesExist);
    void __fastcall SetProfile(); // move data from controls to profile structure
    void __fastcall GetProfile(); // move data from profile to controls
    void __fastcall SetProfileImages(TTreeNode *anode);
    void __fastcall SetNothingSelected();
    void __fastcall LoadTreeView();
    void __fastcall ClearTree();
};

class TNewsProfile : public TStringList
{
public:
   __property AnsiString name        =  { read=Server, write=SetServer };
   __property AnsiString server      =  { read=Server, write=SetServer };
   __property AnsiString userid      =  { read=UserID, write=SetUserID };
   __property AnsiString password    =  { read=Password, write=SetPassword };
   __property bool download          =  { read=Download, write=SetDownload };

   TStringList *newsgroups;
   TNewsgroupProfile* __fastcall newsgroup(int index);
   TNewsgroupProfile* __fastcall newsgroup(AnsiString name);
   virtual __fastcall TNewsProfile();
   virtual __fastcall TNewsProfile(TStrings *profile);
   virtual __fastcall~TNewsProfile();
   void __fastcall SetRawProfile(TStrings *RawProfile);
   void __fastcall GetRawProfile(TStrings *RawProfile);
   void __fastcall GetRawProfile4Ini(TStrings *RawProfile);
   AnsiString __fastcall Server();
   void __fastcall SetServer(AnsiString &server);
   AnsiString __fastcall UserID();
   void __fastcall SetUserID(AnsiString &userid);
   AnsiString __fastcall Password();
   void __fastcall SetPassword(AnsiString &password);
   bool __fastcall Download();
   void __fastcall SetDownload(bool Down);
   bool __fastcall IsEmpty();
   virtual void __fastcall Clear();
};
//---------------------------------------------------------------------------
extern TNewsProfDlg *NewsProfDlg;
//---------------------------------------------------------------------------
#endif
