/*
*  QSNewsWins.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "qsnewsver.h"
#include "QSNewsWins.h"
#include "NewsManDlgs.h"
#include "NewsNewDlgs.h"
#include "NewsPasDlgs.h"
#include "NewsProfDlgs.h"
#include "NewsTransDlgs.h"
#include "QSnewsVer.h"
#include "helpDlgs.h"
#include "Fileman.h"
#include "Headman.h"
#include "nymmail.h"
#include "Newsmail.h"
//---------------------------------------------------------------------------
#pragma link "NntpCli"
#pragma link "explbtn"
#pragma resource "*.dfm"
TQSNewsWin *QSNewsWin;
const AnsiString newsmanflag = "-manager";
const AnsiString newsgetflag = "-getnews";
const AnsiString mailgetflag = "-getmail";
const AnsiString newstrnflag = "-transfer";
const AnsiString newsunaflag = "-unattended";
const AnsiString NNTPProgress = "NNTP Progress";
const AnsiString LastMessageNumbers = "Message Numbers";
const AnsiString UserMailboxesInbox = UserMailboxes+PS+"Inbox";
//#define DISP(m) display->Add(m)
//---------------------------------------------------------------------------
bool __fastcall HasEsub()
{
   return hEsubLib!=NULL;
}
//---------------------------------------------------------------------------
bool __fastcall NeedsEsub(TNewsProfileList *profiles)
{
   bool needesub=false;
   for (int p=0; p<profiles->Count; p++)
   {
      TNewsProfile *profile=profiles->profile(p);
      for (int n=0; n<profile->newsgroups->Count; n++)
      {
         TNewsgroupProfile *newsgroup = profile->newsgroup(n);
         for (int s=0; s<newsgroup->subjects->Count; s++)
         {
            if (newsgroup->subjects->Strings[s].Pos("esub=")==1)
            {
               needesub = true;
               break;
            }
         }
         if (needesub)
            break;
      }
      if (needesub)
         break;
   }
   return needesub;
}
//---------------------------------------------------------------------------
__fastcall TQSNewsWin::TQSNewsWin(TComponent* Owner)
	: TForm(Owner)
{
  // write the version to the ini for QS 'About' check
    if (ParamCount()>0 && ParamStr(1)=="-version")
    {
       PutAppIni("version",ReleaseVer,AppNewsIni);
       Application->ShowMainForm = false;
       PostMessage(Handle,WM_QUIT,0,0);
       return;
    }

    Caption = Caption+" "+ReleaseVer;
   // if AppNewsDat exists copy it to AppMainDat
   if (FileExists(AppNewsDat) && FileExists(AppMainDat))
   {
      HandleNewsgroupMail(NULL);
      if (ParamCount()>0 && ParamStr(1)==newstrnflag)
      {
         Application->ShowMainForm = false;
         PostMessage(Handle,WM_QUIT,0,0);
      }
   }
   // begin initialization
   dogetnews = false;
   unattended = false;
   SecureMode = !FileExists(AppMainDat);// && FileExists(AppMainPgp);
   if (SecureMode && !FileExists(AppNewsIni))
   {
      MsgDlg(NULL,
         s("I see your QS database is encrypted. Also, your 'QSnews.ini' file is missing.\n")+
         s("It contains the basic server/newsgroup info necessary to retrieve your mail\n")+
         s("when QS is not open.\n\n")+
         s("It can be recreated by:\n")+
         s("1) open QS\n")+
         s("2) open QSnews\n")+
         s("3) modify the server or newsgroup info\n")+
         s("4) close QSnews."),
         s("Fatal Error"),MB_OK);
      Application->ShowMainForm = false;
      PostMessage(Handle,WM_QUIT,0,0);
      return;
   }
   // initialize window position
   AnsiString windowstate = GetAppIni("WindowState","",AppIni);
   TWindowState winstate = (TWindowState)GetToken(0,windowstate," ").ToIntDef(wsNormal);
   winpos = GetToken(1,windowstate," ");
   Color = (TColor)GetToken(2,windowstate," ").ToIntDef(clTeal);
   if (windowstate.IsEmpty()) Color = (TColor)GetAppIni(WorkSpaceColor,"").ToIntDef(clTeal);
   if (winpos.IsEmpty())
   {
      winstate = (TWindowState)GetAppIni("WinState","",AppIni).ToIntDef(0);
      winpos = GetAppIni("WinPosition","",AppIni);
   }
   // initialize window position
   int h = 354;
   int w = 516;
   int x = (Screen->Width-w)/2;
   int y = (Screen->Height-h)/2;
   if (winpos.IsEmpty()) winpos=s(x)+","+s(y)+","+s(w)+","+s(h);
   Left   = GetParam(0,winpos,",").ToIntDef(x);
   Top    = GetParam(1,winpos,",").ToIntDef(y);
   Width  = GetParam(2,winpos,",").ToIntDef(w);
   Height = GetParam(3,winpos,",").ToIntDef(h);
   // adjust position to screen if something is out of wak
   if (Height > Screen->Height) Height = Screen->Height;
   if (Width > Screen->Width) Width = Screen->Width;
   if (Left+Width > Screen->Width) Left = Screen->Width-Width;
   if (Top+Height > Screen->Height-28) Top = Screen->Height-28-Height;
   if (Left < -1) Left = -1;
   if (Top < -1) Top = -1;
   WindowState = winstate;
   /*if (!SecureMode)
   {
      hWndQS = FindWindow("TQSMainWin",NULL);
      if (hWndQS && IsWindow(hWndQS) && IsWindowVisible(hWndQS))
      {
         WINDOWPLACEMENT winplace;
         winplace.length = sizeof(WINDOWPLACEMENT);
         if (GetWindowPlacement(hWndQS,&winplace))
         {
            UINT sc=winplace.showCmd;
            if (sc==SW_SHOWNORMAL || sc==SW_RESTORE)
            {
               Position = poDesigned;
               int L=winplace.rcNormalPosition.left;
               int T=winplace.rcNormalPosition.top;
               int W=winplace.rcNormalPosition.right-L;
               int H=winplace.rcNormalPosition.bottom-T;
               Left = L+((W-Width)/2); Top = T+((H-Height)/2);
               if (Top+Height>Screen->Height) Top = Screen->Height-28-Height;
               if (Left+Width>Screen->Width) Left = Screen->Width-Width;
               if (Left<0) Left = 0;
               if (Top<0) Top = 0;
            }
         }
      }
   }*/
   DisplayMemo->Clear();
   Panel3->Align = alClient;
   display = DisplayMemo->Lines;
   hEsubLib = LoadLibrary("psesub32.dll");
   profiles = new TNewsProfileList(SecureMode?AppNewsIni:AppMainDat);
   if (!HasEsub() && NeedsEsub(profiles))
   {
      MsgDlg(NULL,
         s("I have a problem. The file 'psesub32.dll' is not in the QS home directory.\n")+
         s("It provides 'encrypt-subject' services for the QSnews Plugin. I've looked\n")+
         s("at your new account profiles and you do make use of the esub feature.\n\n")+
         s("You can most easily fix the problem by:\n")+
         s("1) close QSnews\n")+
         s("2) open QS\n")+
         s("3) open the Update Wizard\n")+
         s("4) get the latest update for QSnews.\n\n")+
         s("It won't matter if it is the same version you have."),
         s("File PSESUB32.DLL Missing"),
         MB_OK);
      Application->ShowMainForm = false;
      PostMessage(Handle,WM_QUIT,0,0);
      return;
   }
   DisplayNewsgroupsToDownload();
   working = false;

   PutAppIni("version",ReleaseVer,AppNewsIni);
   AccountsBtn->Visible = !SecureMode;
   article = new TMemoryStream();
   subjects = new TStringList();
   message = new TStringList();
   InSubject = false;
   InBody = false;
   InHead = false;
   mails = 0;
   lastmessagenum = new TStringList();
   estimated = curmessage = curprofile = curgroup = -1;
   cap = Caption;

   if (ParamCount())
   {
      int i=0; while(++i<=ParamCount())
      {
         AnsiString paramstr = ParamStr(i);

         if (paramstr==newsmanflag)
         {
            if (RunNewsProfileManager(this,profiles,dogetnews))
            {
               DisplayNewsgroupsToDownload();
               profiles->Save();
            }
            if (dogetnews) break;
            Application->ShowMainForm = false;
            PostMessage(Handle,WM_QUIT,0,0);
            return;
         }

         if (paramstr==newsgetflag || paramstr==mailgetflag)
         {
            dogetnews = true;
            Caption = NNTPProgress;
            AccountsBtn->Visible = GetBtn->Visible = HelpBtn->Enabled = false;
            CancelBtn->Caption = "Cancel";
            CancelBtn->Default = true;
            ActiveControl = DisplayMemo;
            DisplayMemo->Clear();
            continue;
         }

         if (paramstr==newsunaflag)
         {
            unattended = true;
         }
      }
      if (dogetnews) Timer1->Enabled = true;
   }
}
//---------------------------------------------------------------------------
/*__fastcall TQSNewsWin::TQSNewsWin(TComponent* Owner)
	: TForm(Owner)
{
   Caption = Caption+" "+ReleaseVer;
   // if AppNewsDat exists copy it to AppMainDat
   if (FileExists(AppNewsDat) && FileExists(AppMainDat))
   {
      HandleNewsgroupMail(NULL);
      if (ParamCount()>0 && ParamStr(1)==newstrnflag)
      {
         Application->ShowMainForm = false;
         PostMessage(Handle,WM_QUIT,0,0);
      }
   }
   // begin initialization
   dogetnews = false;
   unattended = false;
   SecureMode = !FileExists(AppMainDat);// && FileExists(AppMainPgp);
   if (SecureMode && !FileExists(AppNewsIni))
   {
      MsgDlg(NULL,
         s("I see your QS database is encrypted. Also, your 'QSnews.ini' file is missing.\n")+
         s("It contains the basic server/newsgroup info necessary to retrieve your mail\n")+
         s("when QS is not open.\n\n")+
         s("It can be recreated by:\n")+
         s("1) open QS\n")+
         s("2) open QSnews\n")+
         s("3) modify the server or newsgroup info\n")+
         s("4) close QSnews."),
         s("Fatal Error"),MB_OK);
      Application->ShowMainForm = false;
      PostMessage(Handle,WM_QUIT,0,0);
      return;
   }
   hWndQS = FindWindow("TQSMainWin",NULL);
   if (!SecureMode && (hWndQS=FindWindow("TQSMainWin",NULL))!=NULL &&
      IsWindow(hWndQS) && IsWindowVisible(hWndQS))
   {
      Position = poDesigned;
      int LFTP=SendMessage(hWndQS,WM_NYMWIZHERE,1,NULL);
      int WDHT=SendMessage(hWndQS,WM_NYMWIZHERE,2,NULL);
      int L=LOWORD(LFTP),T=HIWORD(LFTP);
      int W=LOWORD(WDHT),H=HIWORD(WDHT);
      Left = L+((W-Width)/2);
      Top = T+((H-Height)/2);
      if (Left<0) Left = 0;
      if (Top<0) Top = 0;
   }
   DisplayMemo->Clear();
   Panel3->Align = alClient;
   display = DisplayMemo->Lines;
   hEsubLib = LoadLibrary("psesub32.dll");
   profiles = new TNewsProfileList(SecureMode?AppNewsIni:AppMainDat);
   if (!HasEsub() && NeedsEsub(profiles))
   {
      MsgDlg(NULL,
         s("I have a problem. The file 'psesub32.dll' is not in the QS home directory.\n")+
         s("It provides 'encrypt-subject' services for the QSnews Plugin. I've looked\n")+
         s("at your new account profiles and you do make use of the esub feature.\n\n")+
         s("You can most easily fix the problem by:\n")+
         s("1) close QSnews\n")+
         s("2) open QS\n")+
         s("3) open the Update Wizard\n")+
         s("4) get the latest update for QSnews.\n\n")+
         s("It won't matter if it is the same version you have."),
         s("File PSESUB32.DLL Missing"),
         MB_OK);
      Application->ShowMainForm = false;
      PostMessage(Handle,WM_QUIT,0,0);
      return;
   }
   DisplayNewsgroupsToDownload();
   working = false;

   PutAppIni("version",ReleaseVer,AppNewsIni);
   AccountsBtn->Visible = !SecureMode;
   article = new TMemoryStream();
   subjects = new TStringList();
   message = new TStringList();
   InSubject = false;
   InBody = false;
   InHead = false;
   mails = 0;
   lastmessagenum = new TStringList();
   estimated = curmessage = curprofile = curgroup = -1;
   cap = Caption;

   if (ParamCount())
   {
      int i=0; while(++i<=ParamCount())
      {
         AnsiString paramstr = ParamStr(i);

         if (paramstr==newsmanflag)
         {
            if (RunNewsProfileManager(this,profiles,dogetnews))
            {
               DisplayNewsgroupsToDownload();
               profiles->Save();
            }
            if (dogetnews) break;
            Application->ShowMainForm = false;
            PostMessage(Handle,WM_QUIT,0,0);
            return;
         }

         if (paramstr==newsgetflag)
         {
            dogetnews = true;
            Caption = NNTPProgress;
            AccountsBtn->Visible = GetBtn->Visible = HelpBtn->Enabled = false;
            CancelBtn->Caption = "Cancel";
            CancelBtn->Default = true;
            ActiveControl = DisplayMemo;
            DisplayMemo->Clear();
            continue;
         }

         if (paramstr==newsunaflag)
         {
            unattended = true;
         }
      }
      if (dogetnews) Timer1->Enabled = true;
   }
}
*/
//---------------------------------------------------------------------------
__fastcall TQSNewsWin::~TQSNewsWin()
{
   if (hEsubLib) FreeLibrary(hEsubLib);
   delete lastmessagenum;
   delete message;
   delete subjects;
   delete article;
   delete profiles;
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::DisplayNewsgroupsToDownload()
{
   DisplayMemo->Clear(); Snooze(100);
   //display->Add("CURRENT DOWNLOAD CONFIGURATION");
   for (int p=0; p<profiles->Count; p++)
   {
      profile = profiles->profile(p);
      if (profile->download)
      {
         display->Add(profile->name);
         for (int g=0; g<profile->newsgroups->Count; g++)
            if (profile->newsgroup(g)->download)
            {
               AnsiString group = profile->newsgroup(g)->name;
               if (profile->newsgroup(g)->downloadall) group += " /all";
               display->Add(" "+group);
            }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::Exit1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::OpenNewsItemClick(TObject *Sender)
{
   if (RunNewsProfileManagerNoGet(this,profiles))
   {
      DisplayNewsgroupsToDownload();
      profiles->Save();
   }
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   if (dogetnews) GetBtn->Click();
}
//---------------------------------------------------------------------------
/*void __fastcall TQSNewsWin::SetProfileLastMessageNum(AnsiString &descrip)
{
   TNewsProfile *profile; TNewsgroupProfile *newsgroup;
   AnsiString profilename=GetToken(0,descrip,"|"),groupname=GetToken(1,descrip,"|");
   int lastnum = GetToken(2,descrip,"|").ToIntDef(-1);
   for (int p=0; p<profiles->Count; p++)
   {
      profile = profiles->profile(p);
      if (profile->name==profilename)
      {
         for (int g=0; g<profile->newsgroups->Count; g++)
         {
            newsgroup = profile->newsgroup(g);
            if (newsgroup->name==groupname)
                newsgroup->lastmessagenum = lastnum;
         }
      }
   }
   profiles->Save();
}*/
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::GetBtnClick(TObject *Sender)
{
   SetRedraw(Panel1,0);
   Caption = "NNTP Progress"; cap = Caption;
   CancelBtn->Caption = "Cancel";
   AccountsBtn->Visible = GetBtn->Visible = false;
   ActiveControl = DisplayMemo;
   display->Clear();
   curprofile = -1;
   mails = 0;
   SetRedraw(Panel1,1);
   GetTheMail();
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::CancelBtnClick(TObject *Sender)
{
   if (CancelBtn->Caption=="Cancel")
   {
      cancel = true;
      if (!connected) SetLastLine("USER Cancelled Operation!");
      NNTP->Abort();
      if (mails==1) display->Add("1 new message");
      else if (mails>1) display->Add(s(mails)+" new messages");
      AccountsBtn->Visible = !SecureMode; GetBtn->Visible = true;
      ProgressBar->Visible = false;
      CancelBtn->Caption = "Ok";
      working = false;
      curprofile--;
      return;
   }
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (working)
   {
      CancelBtn->Click();
      CanClose = false;
      return;
   }
   if (WindowState != wsMaximized)
      winpos = s(Left)+","+s(Top)+","+s(Width)+","+s(Height);
   PutAppIni("WindowState",s(WindowState)+" "+winpos+" "+s(Color),AppIni);
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::SetEditRect()
{
   TRect Rct = Rect(3,0,DisplayMemo->ClientWidth-4,ClientHeight);
   DisplayMemo->Perform(EM_SETRECT,0,long(&Rct));
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::FormResize(TObject *Sender)
{
   HelpBtn->Left = Width-HelpBtn->Width-20;
   CancelBtn->Left = HelpBtn->Left-CancelBtn->Width-8;
   GetBtn->Left = CancelBtn->Left-GetBtn->Width-8;
   AccountsBtn->Left = GetBtn->Left-AccountsBtn->Width-8;
   ProgressBar->Width = CancelBtn->Left-30;
   SetEditRect();
}
//---------------------------------------------------------------------------
bool __fastcall TQSNewsWin::GetTheMail()
{
   curgroup = -1;
   while (connected) AppProcessMessages();
start:
   if ((profile=profiles->profile(++curprofile))==NULL)
   {
      if (!mails) display->Add("No mail");
      else
      {
         display->Add(s(mails)+s(" new message")+(mails>1?"s":""));
         if (!SecureMode && (hWndQS=FindWindow("TQSMainWin",NULL))!=NULL && IsWindowVisible(hWndQS))
         {
           SendMessage(hWndQS,WM_OPENINBOX,0,NULL);
           Snooze(200);
           Close();
           return false;
         }
      }
      if (unattended)
      {
         Close();
         return false;
      }
      AccountsBtn->Visible = !SecureMode; GetBtn->Visible = true;
      return false;
   }
   if (!profile->download || !profile->newsgroups->Count)
      goto start;

   bool remember;
   working = true; cancel = false;
   HelpBtn->Enabled = false;

   NNTP->Host = profile->server;
   NNTP->UserName = profile->userid;
   NNTP->PassWord = profile->password;
   AnsiString password = profile->password;
   if (!NNTP->UserName.IsEmpty() && NNTP->PassWord.IsEmpty())
   {
      NNTP->PassWord = GetAccountPassword(this,SecureMode,remember);
      if (remember && !NNTP->PassWord.IsEmpty())
      {
         profile->password = NNTP->PassWord;
         profiles->Save();
      }
   }
   display->Add("Connecting to "+profile->server+"...");
   NNTP->Connect();
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall DropCrLf(AnsiString line)
{
   int L = line.Length();
   if (line.Pos("\r\n")>L-2) line = line.SubString(1,L-2);
   return line;
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::NNTPDisplay(TObject *Sender, PChar Msg, int Len)
{
   if (!InHead && !InBody && !InSubject)
   {
      AnsiString msg = DropCrLf(Msg);
      if (msg.Pos("223 ")==1) msg = " "+GetToken(1,msg," ");
      if (msg.Pos("421 ")==1 || msg.Pos("211 ")==1) return;
      if (msg.Pos("205 .")==1) return;
      if (msg.Pos("423 ")==1) return;
      display->Add(" "+msg);
   }
}
//---------------------------------------------------------------------------
void __fastcall ParseResponse(AnsiString Response, AnsiString &Newsgroup, int &MsgEstimate,
   int &FirstMessage, int &LastMessage, char &PostFlag)
{
   AnsiString token;
   int toc=0; while((token=GetToken(toc,Response," ").Trim())!="")
   {
      switch (toc)
      {
         case 1: MsgEstimate =  token.ToIntDef(-1); break;
         case 2: FirstMessage = token.ToIntDef(-1); break;
         case 3: LastMessage =  token.ToIntDef(-1); break;
         case 4: Newsgroup = token; break;
      }
      toc++;
   }
}
//---------------------------------------------------------------------------
int __fastcall TQSNewsWin::GetNextArticleNumber()
{
   return GetToken(1,NNTP->LastResponse," ").ToIntDef(-1);
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::SetLastArticle(AnsiString &disposed)
{
   AnsiString msg = display->Strings[display->Count-1];
   display->Strings[display->Count-1] = msg + disposed;
}
//---------------------------------------------------------------------------
int __fastcall TQSNewsWin::GetNewsgroupStartMessageNum()
{
   AnsiString name; char flag;
   int pick=-1,firstavail,esti,thelast=newsgroup->lastmessagenum+1;

   ParseResponse(NNTP->LastResponse,name,esti,firstavail,lastavail,flag); estimated=esti;
   //sm(NNTP->LastResponse+"\n"+name+" "+s(estimated)+" "+s(firstavail)+" "+s(lastavail)+" "+s(flag));
   if (thelast<=0 || thelast>lastavail+1)
   {
      if ((pick=GetNewNewsgroupDownloadCount(this,name,estimated))<0)
      {
         display->Add(" Operation cancelled!");
         cancel = true;
         NNTP->Quit();
         return pick;
      }
      pick = lastavail-(pick-1);
      if (pick<firstavail) pick = firstavail;
   }
   if (!pick && thelast<firstavail) thelast = firstavail;
   lastread = pick>0 ? pick : thelast;
   display->Add(" 211 "+s(lastavail-(lastread-1))+" "+s(lastread-1)+" "+
      s(lastavail)+" "+name+s(newsgroup->downloadall?" /all":""));
   return lastread;
}
//---------------------------------------------------------------------------
//void __fastcall TQSNewsWin::DisplayMessageRetrieveRange()
//{
//  display->Add(" Retrieving from "+s(lastread)+" to "+s(lastavail)+
//     " (estimated "+s(lastavail-(lastread-1))+" articles)");
//}
//---------------------------------------------------------------------------
AnsiString __fastcall TQSNewsWin::NewsServerCount()
{
   int curr=curmsg-(lastread-1),final=lastavail-(lastread-1);
   return s(curr)+" of "+s(final<curr?curr:final)+" ("+s(mails)+")";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TQSNewsWin::NewsServerNameCaption()
{
   return "USENET HOST:  "+profile->name;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TQSNewsWin::NewsServerNameAndCountCaption()
{
   return "NNTP Progress  "+NewsServerCount();
 //return NewsServerNameCaption()+"   article "+NewsServerCount();
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetCurmsgAndSubject(int &curmsg, AnsiString subject)
{
   curmsg = GetToken(0,subject," ").ToIntDef(-1);
   return "Subject: "+subject.SubString(subject.Pos(" ")+1,256);
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::NNTPRequestDone(TObject *Sender, TNntpRequest RqType,
	WORD Error)
{
   AnsiString name,msg,subject;
   if (Error && Error!=421 && Error!=423 && Error!=400 && Error!=411)
   {
      display->Add("Aborting...");
      NNTP->Abort();
      return;
   }
   switch(RqType)
   {
      case nntpConnect:
      case nntpAuthenticate: // nntp->authenticate done in SessionConnected below
         newsgroup = profile->newsgroup(++curgroup);
         if (!newsgroup)
         {
            NNTP->Quit();
            return;
         }
         if (!newsgroup->download)
         {
            NNTPRequestDone(this,nntpConnect,0);
            return;
         }
         NNTP->Group(newsgroup->name);
         return;
      case nntpGroup:
         if (NNTP->StatusCode!=211 && NNTP->StatusCode!=411)
         {
            display->Add("Aborting...");
            NNTP->Abort();
            return;
         }
         if (NNTP->StatusCode==411) // no such group
         {
            NNTPRequestDone(this,nntpConnect,0);
            return;
         }
         estimated = -1;
         if ((curmsg=GetNewsgroupStartMessageNum())>lastavail || curmsg==-1)
         {
            NNTPRequestDone(this,nntpConnect,0);
            return;
         }
         cursub = -1;
         display->Add(" Retrieving headers...");
         ProgressBar->Position = 0;
         ProgressBar->Visible = true;
         subjects->Clear();
         msg = "";
         InSubject = true;
         NNTP->XHdr("subject",s(curmsg)+"-",NULL);
         return;
      case nntpXHdr:
         if (InSubject)
         {
            int c = lastavail-(lastread-1);
            if (c==1) msg = " Scanning 1 new message";
            else if (c>1) msg = " Scanning "+s(c)+" new headers";
            DisplayMemo->Lines->Strings[DisplayMemo->Lines->Count-1] = msg;
         }
         InSubject = false;
         AppProcessMessages();
//view(subjects,s(cursub));
         while (++cursub<subjects->Count)
         {
            message->Text = GetCurmsgAndSubject(curmsg,subjects->Strings[cursub]);
            if (!cancel)
            {

               newsgroup->lastmessagenum = curmsg; //profiles->Save();
               if (SecureMode || newsgroup->downloadall || newsgroup->subjectmatch(message))
               {
                  InHead = true;
                  NNTP->HeadByNumber(curmsg,NULL);
                  return;
               }
            }
         }
         NNTPRequestDone(this,nntpConnect,0);
         //NNTP->Quit();
         return;
      case nntpHeadByNumber:
         InHead = false;

// start error check for rider
//if (NNTP->StatusCode!=221)
//MsgDlg(this,"The status code for this article is "+s(NNTP->StatusCode),
//"ARTICLE: "+s(curmsg),MB_OK);
// end error check for rider

         if (!cancel && NNTP->StatusCode==221)
         {
            InBody = true;
            ProgressBar->Position = 0;
            ProgressBar->Visible = true;
            //Caption = NewsServerNameAndCountCaption();
            Application->Title = "QSnews "+NewsServerCount();
            //display->Strings[display->Count-1] = " Retrieving message "+NewsServerCount();
            display->Add(" Retrieving message "+NewsServerCount());
            NNTP->BodyByNumber(curmsg,NULL);
            return;
         }
         newsgroup->lastmessagenum--;
         NNTPRequestDone(this,nntpConnect,0);
         //NNTP->Quit();
         return;
      case nntpBodyByNumber:
         InBody = false;
         display->Strings[display->Count-1] = " Retrieving message "+NewsServerCount();
         AppProcessMessages();
         if (!cancel)
         {
            NNTPRequestDone(this,nntpXHdr,0);
            return;
         }
         newsgroup->lastmessagenum--;
         NNTPRequestDone(this,nntpConnect,0);
         //NNTP->Quit();
         return;
      case nntpQuit:
      case nntpAbort:
         profiles->Save();
         if (!cancel && curgroup<profile->newsgroups->Count-1)
         {
            NNTPRequestDone(this,nntpConnect,0);
            return;
         }
         Application->Title = "QSnews Done! ("+s(mails)+")";
         HelpBtn->Enabled = GetBtn->Visible = true;
         AccountsBtn->Visible = !SecureMode;
         ProgressBar->Visible = false;
         working = false;
         Caption = cap;
         if (RqType==nntpAbort) return;
         GetTheMail();
   }
}
//---------------------------------------------------------------------------
// Original NNTPRequestDone
/*void __fastcall TQSNewsWin::NNTPRequestDoneX(TObject *Sender, TNntpRequest RqType,
	WORD Error)
{
   AnsiString name;
   if (Error && Error!=421 && Error!=423)
   {
    //display->Add("Error returned: "+s(Error)+" "+s(curmsg)+" "+NNTP->LastResponse);
      if (Error!=400) display->Add(connected?" Aborting...":"Aborted");
      NNTP->Abort();
      cancel = true;
      return;
   }
   switch(RqType)
   {
      case nntpConnect:
      case nntpAuthenticate: // nntp->authenticate done in SessionConnected below
         newsgroup = profile->newsgroup(++curgroup);
         if (!newsgroup)
         {
            NNTP->Quit();
            return;
         }
         if (!newsgroup->download)
         {
            NNTPRequestDone(this,nntpConnect,0);
            return;
         }
         NNTP->Group(newsgroup->name);
         return;
      case nntpGroup:
         if (NNTP->StatusCode!=211)
         {
            display->Add("Aborting...");
            cancel = true;
            Caption = cap;
            NNTP->Abort();
            return;
         }
         if ((curmsg=GetNewsgroupStartMessageNum())>lastavail)
         {
            NNTPRequestDone(this,nntpConnect,0);
            Caption = cap;
            return;
         }
         NNTP->StatByNumber(curmsg);
         return;
      case nntpStatByNumber:
         if (NNTP->StatusCode>=400 && curmsg<=lastavail) // 412,424,423,430
         {
            NNTP->StatByNumber(++curmsg);
            return;
         }
         if (curmsg>lastavail)
         {
            NNTPRequestDone(this,nntpConnect,0);
            Caption = cap;
            return;
         }
      case nntpNext:
         if (RqType==nntpNext && NNTP->StatusCode!=223)
         {
            NNTPRequestDone(this,nntpConnect,0);
            Caption = cap;
            return;
         }
         curmsg = GetNextArticleNumber();
         InHead = true; InBody = false;
         Caption = NewsServerNameAndCountCaption();
         Application->Title = "QSnews "+NewsServerCount();
         NNTP->HeadByNumber(curmsg,NULL);
         return;
      case nntpHeadByNumber:
         InHead = false;
         if (!newsgroup->downloadall && !newsgroup->subjectmatch(message))
         {
            SetLastArticle(" skipping "); Snooze(100);
            display->Delete(display->Count-1);
            newsgroup->lastmessagenum = curmsg;
            profiles->Save();
            if (!cancel) NNTP->Next();
            return;
         }
         if (NNTP->StatusCode==221)
         {
            InBody = true;
            ProgressBar->Position = 0;
            ProgressBar->Visible = true;
            NNTP->BodyByNumber(curmsg,NULL);
            return;
         }
         if (!cancel) NNTP->Next();
         return;
      case nntpBodyByNumber:
         //ProgressBar->Visible = false;
         InHead = InBody = false;
         if (NNTP->StatusCode==222)
         {
            ProgressBar->Position = 0;
          //SetLastArticle(" ok");
            if (!cancel) NNTP->Next();
            return;
         }
         Caption = cap;
         if (!cancel) NNTP->Next();
         return;
      case nntpQuit:
      case nntpAbort:
         Application->Title = "QSnews Done! ("+s(mails)+")";
         AccountsBtn->Visible = !SecureMode; GetBtn->Visible = true;
         ProgressBar->Visible = false;
         FileMenu->Enabled = HelpBtn->Enabled = true;
         working = false;
         Caption = cap;
         if (RqType==nntpAbort) return;
         GetTheMail();
   }
}*/
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::NNTPSessionConnected(TObject *Sender, WORD Error)
{
   connected = true;
   //Caption = NewsServerNameCaption();
   if (!NNTP->UserName.IsEmpty())
   {
      NNTP->Authenticate();
      return;
   }
   NNTPRequestDone(NULL,nntpConnect,0);
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::SetLastLine(AnsiString msg)
{
   if (display->Count && display->Strings[display->Count-1]!=msg)
       display->Add(msg);
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::NNTPSessionClosed(TObject *Sender, WORD Error)
{
   if (cancel) SetLastLine("USER Cancelled Operation!");
   SetLastLine("Connection closed!");
   AccountsBtn->Visible = !SecureMode; GetBtn->Visible = true;
   CancelBtn->Caption = "Ok";
   connected = false;
}
//---------------------------------------------------------------------------
bool __fastcall TQSNewsWin::SaveMessageViaQS(HWND hWndQS, TStrings *Message)
{
   int length = message->Text.Length()+1;
   char *msg = new char[length];
   strcpy(msg,message->Text.c_str());
   COPYDATASTRUCT copydata;
   copydata.dwData = WM_INCOMINGMAIL;
   copydata.cbData = length;
   copydata.lpData = msg; // try copydata, if fail putappdata
   if (SendMessage(hWndQS,WM_COPYDATA,(UINT)Handle,(LPARAM)&copydata)==6666)
      return true;
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::SaveMessage(TStrings *Message)
{
   PutAppData(UserMailboxesInbox+PS+InIndexString(Message),Message,
      SecureMode?AppNewsDat:AppMainDat);
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::NNTPMessageBegin(TObject *Sender)
{
   if (InHead)
   {
      message->Clear();
      curline = 0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::NNTPMessageEnd(TObject *Sender)
{
   if (cancel) return;
   if (InSubject)
   {
      ProgressBar->Position = 100; Snooze(100);
      ProgressBar->Visible = false;
      return;
   }
   if (curline==bodlines)
   {
      ProgressBar->Position = 100;
      Snooze(20);
   }
   THeaderManager *hm = new THeaderManager(message);
   if (InHead)
   {
      if (message->Count)
      {
          bodlines = hm->GetDat("Lines: ").ToIntDef(-1);
          ProgressBar->Position = 0;
      }
      message->Add("");
   }
   if (InBody)
   {
      TrimNulls(message);
      Snooze(100); ProgressBar->Position = 0;
      if (SecureMode)
      {
         message->Insert(0,profile->name+"|"+newsgroup->name+"|"+s(curmsg));
         SaveMessage(message);
         mails++;
      }
      else
      {
         if (newsgroup->subjectmatch(message))
         {
            SaveMessage(message);
            mails++;
         }
      }
      newsgroup->lastmessagenum = curmsg;
      profiles->Save();
   }
   delete hm;
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::NNTPMessageLine(TObject *Sender)
{
   if (InSubject)
   {
      ProgressBar->Position = cursub/estimated*100;
      subjects->Add(NNTP->LastResponse);
      return;
   }
   if (InHead)
   {
      message->Add(NNTP->LastResponse);
      return;
   }
   if (InBody)
   {
      ProgressBar->Position = (curline/bodlines)*100;
      message->Add(NNTP->LastResponse);
      curline++;
      return;
   }
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::GetMessagesItemClick(TObject *Sender)
{
   if (GetBtn->Visible) GetBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::HelpBtnClick(TObject *Sender)
{
   OpenHelp("NNTP",
      "QuickSilver NNTP Mail Retrieval System",
      "QuickSilver NNTP Mail Retrieval System"
   );
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::FormShow(TObject *Sender)
{
   /*if (Position==poDesigned)
   {
      Height = 354; Width = 516;
      if (Top+Height>Screen->Height-30) Top = Screen->Height-(Height+30);
      if (Left+Width>Screen->Width-2) Left = Screen->Width-(Width+2);
      if (Left<2) Left = 2;
      if (Top<2) Top = 2;
   }*/
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::Button1Click(TObject *Sender)
{
     AnsiString encrypted,passwd="panties",subject="QuickSilver Database V2.0 January 15, 2003";
     EncryptSubject(subject,passwd,encrypted);
view(encrypted);
}
//---------------------------------------------------------------------------
