/*
*  QSNewsWins.h
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#ifndef QSNewsWinsH
#define QSNewsWinsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include "NewsManDlgs.h"
#include "NewsProfDlgs.h"
#include "NntpCli.hpp"
#include "explbtn.hpp"
#include "global.h"
//---------------------------------------------------------------------------
class TQSNewsWin : public TForm
{
__published:	// IDE-managed Components
   TPanel *Panel1;
   TTimer *Timer1;
	TNntpCli *NNTP;
	TProgressBar *ProgressBar;
	TButton *CancelBtn;
	TButton *HelpBtn;
	TBitBtn *GetBtn;
	TButton *AccountsBtn;
	TPanel *Panel3;
	TRichEdit *DisplayMemo;
        TButton *Button1;
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall OpenNewsItemClick(TObject *Sender);
    void __fastcall GetBtnClick(TObject *Sender);
	void __fastcall NNTPRequestDone(TObject *Sender, TNntpRequest RqType, WORD Error);
	void __fastcall NNTPDisplay(TObject *Sender, PChar Msg, int Len);
	void __fastcall NNTPSessionConnected(TObject *Sender, WORD Error);
	void __fastcall NNTPSessionClosed(TObject *Sender, WORD Error);
	void __fastcall NNTPMessageBegin(TObject *Sender);
	void __fastcall NNTPMessageEnd(TObject *Sender);
	void __fastcall NNTPMessageLine(TObject *Sender);
	void __fastcall GetMessagesItemClick(TObject *Sender);
	void __fastcall CancelBtnClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
        
        void __fastcall Button1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
   HWND hWndQS;
   TStrings *display;
   AnsiString cap,winpos;
   double bodlines,curline,cursub,estimated;
   TMemoryStream *article;
   TNewsProfile *profile;
   TNewsProfileList *profiles;
   TNewsgroupProfile *newsgroup;
   Graphics::TBitmap *chkmail;
   bool cancel,InHead,InBody,InSubject,InMessage,connected,working;
   bool SecureMode,unattended,dogetnews;
   int curmessage,curprofile,curgroup,lastread,curmsg,lastavail,mails;
   TStringList *message,*lastmessagenum,*subjects;
   __fastcall TQSNewsWin(TComponent* Owner);
   virtual __fastcall~TQSNewsWin();
   void __fastcall NNTPRequestDoneX(TObject *Sender, TNntpRequest RqType, WORD Error);
   bool __fastcall NothingMarked(TStrings *profiles);
   void __fastcall SetGetBtnGlyph(bool Visible);
   bool __fastcall GetTheMail();
   void __fastcall DisplayMessageRetrieveRange();
   AnsiString __fastcall NewsServerCount();
   AnsiString __fastcall NewsServerNameCaption();
   AnsiString __fastcall NewsServerNameAndCountCaption();
   int  __fastcall GetNewsgroupStartMessageNum();
   int  __fastcall GetNextArticleNumber();
   void __fastcall SetLastArticle(AnsiString &okskip);
   void __fastcall DisplayNewsgroupsToDownload();
   bool __fastcall SaveMessageViaQS(HWND hWndQS, TStrings *Message);
   void __fastcall SaveMessage(TStrings *Message);
   void __fastcall SetEditRect();
   bool __fastcall ProcessAppNewsDat();
   void __fastcall SetLastLine(AnsiString msg);
   // message handlers
   //void virtual __fastcall WMNewsPooling(TMessage& Msg);
   // message map
   //BEGIN_MESSAGE_MAP
   //MESSAGE_HANDLER(WM_NEWSPOOLING,TMessage,WMNewsPooling)
   //END_MESSAGE_MAP(TForm)
};

void __fastcall SaveNewProfiles();
//---------------------------------------------------------------------------
extern TQSNewsWin *QSNewsWin;
//---------------------------------------------------------------------------
#endif
